/* zbu.cmd - copyright 2006,2010 - Julian Thomas - http://jt-mj.net  */
/* partition by partition backup scheme */
call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs

level = '3.05'
say "zbu - JT's backup program - level" level


parse upper arg argline
q=pos('P=',argline)
if q>0 then do
  parse var  argline pf phase partx .
  parmfile=substr(pf,3)
  end
  else do
  parse var argline phase  partx .
  parmfile='zbuprm'
  end

parse source . . here
j=lastpos('\',here)

parse source . . here
j=lastpos('\',here)


here=left(here,j-1)
hered=here||'\'
junk=directory(here)   /* everything is in program directory  */

to.=''

    pfe=stream(parmfile,'C','QUERY EXISTS')
    if pfe='' then do
           say 'parmfile' parmfile 'not there or invalid;'
           say 'terminating program.'
           exit
           end
    call readparms 



signal on NOVALUE


flagfile=hered||'zbuflag'
cyclefile=hered||'zipcy.fil'
lastbufil='lastbu.fil'
lastbu=hered||lastbufil
logfile=hered||"zbu.log"



/*  2.  determine cycle, subcycle  */

if p.once\=1 then do
   if p.cymax='' then p.cymax=3
   if p.subcymax='' then p.subcymax=5

   cfde=stream(cyclefile,'C','QUERY EXISTS')
   if cfde\='' then do 
              cylin=linein(cyclefile)
              call stream cyclefile,'C','CLOSE'
              end
    else cylin='1 1'

    parse var cylin cycle subcycle .
    cycled=cycle||'\'
    end 

    /*  p.once = 1  */
       else do
            cycle=''
            cycled=''
            subcycle='1'
            end

loglin=date() time() 'ZBU level' level 'phase' phase 
if cycle<>'' then loglin = loglin 'cycle' cycle 'subcycle' subcycle 

if phase='1' then do    /* this is a long do loop  */
/* called from ecs cron job or cmd line.  Do phase1 backups  */
   call lineout logfile,loglin       
   part=p.p1part
   ipart=p.dfsimg1

/* 2a. Warn.  */
   say 'About to initiate zip backup of ecs partitions' part
   say loglin
   say 'You have' p.wait 'secs to break out of this!'
   call syssleep p.wait

if part\='' then call doparts

/* If new  major cycle, do dfsdisk   */
 if p.type.subcycle='F' & p.dfsdir\='' then do
    
     px='9'
     pxd=p.to.px||cycled
    
/*     if p.once=1 then if p.oncedel=1 then do  */
        diagoutlin='del' pxd||px||'*.zip '
        'del' pxd||px||'*.zip '
        call lineout logfile,diagoutlin
/*        end                                   */
     xx=directory(p.dfstemp)
     'del' p.dfstemp||'\* <' hered||'yfile'
     opath = value('PATH',,'OS2ENVIRONMENT')
     npath=p.dfsdir||";"||opath
     call VALUE 'PATH',npath,'OS2ENVIRONMENT'
     do j=1 to p.dfsdisks
         'cmd /c  "'||p.dfsdir||'\dfsdisk.cmd -screen-' j '"'
         'cmd /c  "'||p.dfsdir||'\dfsos2 genpart' j 'genpt -f- "'
          end   /* loop on disks  */

/*  DFS img stuff  ph 1 */
      if p.type.subcycle='F' & ipart\='' then call doimg 
      

      
     junk=directory(here)
     end /* any dfs stuff */

call lineout flagfile,'zbu flag'
call lineout flagfile


    say 'about to shutdown and use setboot to boot maint part'
    
    call syssleep p.wait
    call zclosep1.cmd
say 'setboot' p.p2setboot  
    'setboot' p.p2setboot  
call syssleep 10  /* in case setboot parm is set to /q  */

    'exit'
 end     /* end do for phase1  */
    
if phase=2 then do    
/* normally invoked from startup folder for maint part */

part=p.p2part
ipart=p.dfsimg2

if partx<>'' then part=partx  

/* 1.  look for flag file.  If not there, quit  */
z=stream(flagfile,'C','QUERY EXISTS')
if z='' & partx='' then do
   say 'no flag file present'
   call syssleep 5
   '@exit'
   exit
   end



/* 2a. Warn.  */
   say 'About to initiate zip backup of partitions' part
   outlin='Phase 2 Backup type' p.type.subcycle
   if p.once\=1 then outlin = outlin 'cycle' cycle 'subcycle' subcycle
   outlin=outlin 'partitions' part
   say  outlin
   call lineout logfile,outlin 
   call lineout logfile

   say 'You have' p.wait 'secs to break out of this!'
   call syssleep p.wait

   call lineout logfile,outlin 
   call lineout logfile
      

if part\='' then call doparts


/*  DFS img stuff  ph 2 */
      if p.type.subcycle='F' & ipart\='' then call doimg 


 if p.type.subcycle='F' then do
     px=9
     pxd=p.to.px||cycled
     
     /* save dfs logs and output from p1 & p2   */
     'zip' pxd||'9dfsout'||date('S') p.dfstemp||'\*'
     'del' p.dfstemp||'\*   < yfile'
     end
      
     junk=directory(here)
     


/*4.  clear flagfile  */
call sysfiledelete flagfile

/*5.  if not ONCE and not partial increment cycle  */

if p.once \=1 && partx \= '' then do
     if subcycle=p.subcymax then do
           cycle=cycle+1
           subcycle=1
           if cycle=p.cymax+1 then cycle=1
           end
           else subcycle=subcycle+1
           
   call sysfiledelete lastbu
   'rename' cyclefile||','||lastbufil
   call lineout cyclefile,cycle subcycle
   call stream cyclefile,'C','CLOSE'
   end 
   
   loglin= 'Finished' date() time()
   if p.once\=1 then loglin=loglin  'NEXT cycle' cycle 'subcycle' subcycle
   call lineout logfile,loglin 
   call lineout logfile,'=================' 
   call lineout logfile

if partx<>'' then do
    say 'No reboot for manual'
    'exit'
    end
   

say 'pausing 10 sec before reboot to break out if you want'
call syssleep 10

call zclosep2.cmd
      

say 'issuing setboot' p.p1setboot

'setboot' p.p1setboot
call syssleep 10  /* in case setboot parm is set to /q  */


'exit'

end /* arg = 2 */

say 'zbu.cmd is not intended for casual execution.  Nothing happening'
say 'manual usage:  zbu [p=parmfile] phase (1 or 2) [partlist - phase 2 only]'
exit

doimg:  procedure expose p. ipart logfile to. cycled subcycle here hered phase
do while length(IPART)>0
   parse var ipart ipx ';' rest
   ipart=rest


           xx=directory(p.dfstemp)
           imagp=p.dfsimg||ipx
           say imagp
           ifn=p.to.imagp 
           ifn=ifn||cycled||imagp||'_DFSimg'||date('S')
           imgcmd='image' ifn||' 0 -P:'||imagp '-z -S' p.dfsimgflags
           loglin="About to do dfsimage of" imagp "cmd" imgcmd
           call lineout logfile,loglin
           call lineout logfile
           'cmd /c "'||p.dfsdir||'\dfsos2 -l:zbulog'||phase'.log -b -Q' imgcmd '"' 
     /* 'cmd /c "g:\os2progs\dfsee\dfsos2" -l:zbudfs.log -b -Q' imgcmd  */

end /* iparts do loop  */

   return  /* image */



doparts: procedure expose p. part logfile to. cycled subcycle here hered

signal on NOVALUE
   
do while length(PART)>0
   parse var part px ';' rest

/*  px = full value - e.g. D  or H:\imagbank
    pxd = drive
    pxx = px with no punctuation for zipfilename
*/
   
   part=rest
   pxd=left(px,1)

say 'about to do zipit of' px
    
j=pos(':\',px)
if j>0 then pxx=left(px,j-1)||substr(px,j+2)
 else pxx=px


if length(px)>1 & p.type.subcycle \= 'F' then do
     outlin='bypassing partial BU of partial partition' px
     say outlin
     call lineout logfile,outlin
     px=''
     end
                             
/*  3.  call zipit   */

if px<>'' then do
    if p.type.subcycle='F' then do
       if p.once\=1 | p.oncedel=1 then do
               /* clear out old one */
               if px=pxd then do
                  diagoutlin='del' p.to.pxd||cycled||pxx||'*.zip '
                  'del' p.to.pxd||cycled||pxx||'*.zip '
                   call lineout logfile,diagoutlin
                   end
               end
       end        
    
    xyz=directory(here)
    say  ''
    outlin= ' calling zipit ' px p.to.pxd||cycled p.type.subcycle
    call lineout logfile,outlin
    say outlin 
    say 'sleeping' p.wait 'sec'
    call syssleep p.wait
                                                 
    call "zipit.cmd" px p.to.pxd||cycled p.type.subcycle  
    xyz=directory(here)
    end /* px<>'' - skipping if not full and not root  */
    end   /* looping on length of part  */
return


/* read params  */
readparms: procedure  expose p. parmfile

/*  anything not specified is default value p.='' */
p.=''
is=stream(parmfile,'c','open read')

do while lines(parmfile)
   line=strip(linein(parmfile))
   if line='' then iterate
   if left(line,2) = '/'||'*' then iterate
   if left(line,1) = ';' then iterate
   if left(line,1) = '#' then iterate
   parse var line parm '=' value
   parm=strip(translate(parm))
   p.parm=strip(value)
   end
is=stream(parmfile,'c','close')

return 