/*  zipit.cmd - Julian Thomas - http://jt-mj.net */
/* Part of zbu backup system.  This program is to
zip one partition or directory.   */

level = 2.01

arg px to full .

compress = '8'    /* zip compression factor  */


if px='' then do
   say 'zipit.cmd level' level
   say 'usage is zipit [driveletter|d:\dir]  targetdirforzipfile type (FD or I)'
   say 'EXAMPLE:  zipit X k:\xbudir\ F'
   say 'target dir must end with a \'
   say 'Normally intended to be called from zbu wrapper cmd file'
   exit
   end
   
   say 'zipit level' level 'called with args' px to full

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs


here=directory()   /* find out where we are now  */

hered=here||"\"

j=pos(':\',px)
if j>0 then do   /* directory of a partition.  EXAMPLE:  X:\mess  */
    pxx=left(px,j-1)||substr(px,j+2)    /* for zipfile name:  XMESS   */
    pxd=px||'\'
    pxq=px
    end
/*    PXX is for zipfile name.
      PXD is directory to be backed up
      PXQ is used to set directory to what we are backing up
*/


 else do       /* full partition - like X  */
    pxx=px
    pxd=px||':\'
    pxq=pxd
    end

logfile=hered||'zbu.log'
tfile=hered||"tmp\zipbu.tmp"
xfil=hered||'exclude-'||pxx
q=stream(xfil,'C','query exists')
if q<>'' then xfile='-x@'||xfil
   else xfile='-x@'||hered||'exclude.def'

say 'Backing up' px
if full <> 'F' then do
   call SysFileDelete tfile

   if full='I' then do     /* incremental - reset A bits  */
      targatt='-****'
      say 'getting files with A bits; resetting A bits'
      end
    else do             /* differential - leave A bits alone  */
      targatt='*****'
      say 'getting files with A bits'
      end

   /*  get filespecs of files with A bits  */
   x=SysFileTree(pxd||'*.*',"stem",'SF','+****',targatt)
   totalsize=0

   if stem.0=0 then do
      outlin='nothing to do for' px
      say outlin
      call lineout logfile,outlin
      call lineout logfile
      call quit
      end

   do i=1 to stem.0           /*  build the list of files for zip  */
         parse value stem.i WITH . . filsiz . filnam
         filnam=STRIP(filnam)
         totalsize=totalsize+filsiz
         call lineout tfile,filnam
         end
   call lineout tfile
   outlin=stem.0 'files totalling' totalsize 'bytes for' px
   say outlin
   call lineout logfile,outlin
   call lineout logfile

   end /* -I or -D a bit processing */


   /* change directory to what we are zipping 
      to avoid problems if it is a fat filesystem */


    xx=directory(pxq)
    mmdd=right(date('S'),4)
        if full=F then do
            say directory()
            zipfile=to||pxx||mmdd||'all.zip'
            'zip -rS'||compress zipfile '.'  xfile    /* xfile is exclude file*/
            zrc=RC
            end
            else do
           zipfile=to||pxx||"-"||full||mmdd||".zip"      /* full is I or D  */
           'zip -rS'||compress zipfile pxd||'* -i@'||tfile  
                                      /* tfile is  list of files to INCLUDE */
            zrc=RC 
            end
xx=directory(here)

x= SysFileTree(zipfile,'ft')
if x=0 then do
parse var ft.1 . . siz .
say 'Zipfile' zipfile 'size:' siz
end
else siz='sysfiletree-of-zipfile-failed'




outlin=date('S') '  ' time('N') '  ' zipfile siz 'zip RC' zrc 
if full <>F then outlin = outlin full stem.0 'files'
say outlin

call lineout logfile,outlin
call lineout logfile
if full='F' then do
   say 'resetting A bits for files:'
   x=SysFileTree(px||':\*.*',"stem",'SF','+****','-****')
   end

quit:    /* exit label  */